"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.default =




applyTemplate;var _fsExtra = require("fs-extra");var _logger = require("../logger");var _logger2 = _interopRequireDefault(_logger);var _utils = require("../utils");function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function applyTemplate(source, target, placeholders) {var clean = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
    var replacements = [];
    for (var key in placeholders) {
        if (placeholders.hasOwnProperty(key)) {
            replacements.push({
                regex: (0, _utils.escapeRegExp)("{{" + key + "}}"),
                replacement: placeholders[key] });

        }
    }
    return (clean ? (0, _fsExtra.emptyDir)(target) : (0, _fsExtra.ensureDir)(target)).
    then(function () {return (0, _utils.copyAndReplace)(source, target, replacements);}).
    then(function () {return _logger2.default.debug("Successfully applied template to: " + source + ".");}).
    catch(function (e) {
        _logger2.default.error("Unable to apply template to: " + source + ". " + e.toString());
        throw new Error("Unable to apply template to: " + source + ".");
    });
}