"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.default =






downloadProxy;var _fsExtra = require("fs-extra");var _streamToPromise = require("stream-to-promise");var _streamToPromise2 = _interopRequireDefault(_streamToPromise);var _unzipStream = require("unzip-stream");var _unzipStream2 = _interopRequireDefault(_unzipStream);var _memorystream = require("memorystream");var _memorystream2 = _interopRequireDefault(_memorystream);var _logger = require("../logger");var _logger2 = _interopRequireDefault(_logger);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function downloadProxy(client, name, path) {var clean = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
    var directory = clean ? (0, _fsExtra.emptyDir)(path) : (0, _fsExtra.ensureDir)(path);
    return directory.then(function () {return client.downloadProxy(name);}).
    then(function (binary) {return (0, _streamToPromise2.default)(new _memorystream2.default(binary).pipe(_unzipStream2.default.Extract({ path: path })));}).
    then(function () {return _logger2.default.info("Successfully downloaded API Proxy archive.");});
}