"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.default =




















extractTemplate;exports.









extractTemplateFromManifest = extractTemplateFromManifest;var _fsExtra = require("fs-extra");var _logger = require("../logger");var _logger2 = _interopRequireDefault(_logger);var _utils = require("../utils");var _downloadProxy = require("./downloadProxy");var _downloadProxy2 = _interopRequireDefault(_downloadProxy);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function getReplacements(placeholders) {var replacements = [];for (var key in placeholders) {if (placeholders.hasOwnProperty(key)) {replacements.push({ regex: (0, _utils.escapeRegExp)(placeholders[key]), value: placeholders[key], replacement: "{{" + key + "}}" });}}replacements.sort(function (a, b) {return b.value.length - a.value.length;});return replacements;}function extractTemplate(source, target, placeholders) {var clean = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;return (clean && source !== target ? (0, _fsExtra.emptyDir)(target) : (0, _fsExtra.ensureDir)(target)).then(function () {return (0, _utils.copyAndReplace)(source, target, getReplacements(placeholders));}).then(function () {return _logger2.default.debug("Successfully extracted template from: " + source + ".");}).catch(function (e) {_logger2.default.error("Unable to extract template from: " + source + ". " + e.toString());throw new Error("Unable to extract template.");});}function extractTemplateFromManifest(client, manifestPath, target) {var clean = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
    return (0, _utils.parseManifest)(manifestPath).
    then(function (_ref) {var proxy = _ref.proxy;
        if (proxy) {
            target = target || proxy.path;
            return (0, _downloadProxy2.default)(client, proxy.name, target, clean).
            then(function () {return extractTemplate(target, target, proxy.placeholders || {});});
        } else {
            _logger2.default.error("Manifest does not contain any proxy definition: " + target + ".");
            return Promise.reject();
        }
    });
}