"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.
















packageProxyToFile = packageProxyToFile;exports.default =






packageProxy;var _archiver = require("archiver");var _archiver2 = _interopRequireDefault(_archiver);var _streamToPromise = require("stream-to-promise");var _streamToPromise2 = _interopRequireDefault(_streamToPromise);var _tmpPromise = require("tmp-promise");var _tmpPromise2 = _interopRequireDefault(_tmpPromise);var _path = require("path");var _fsExtra = require("fs-extra");var _applyTemplate = require("./applyTemplate");var _applyTemplate2 = _interopRequireDefault(_applyTemplate);var _utils = require("../utils");var _logger = require("../logger");var _logger2 = _interopRequireDefault(_logger);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function toZip(path) {var archive = (0, _archiver2.default)("zip");archive.directory(path, "/" + _utils.PROXY_FOLDER);archive.finalize();return archive;}function packageProxyToFile(source, target) {var templated = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;var placeholders = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};return (0, _fsExtra.ensureDir)((0, _path.dirname)(target)).then(function () {return packageProxy(source, templated, placeholders);}).then(function (stream) {return (0, _streamToPromise2.default)(stream.pipe((0, _fsExtra.createWriteStream)(target)));}).then(function () {return _logger2.default.debug("Successfully packaged proxy " + source + ".");});}function packageProxy(path) {var templated = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;var placeholders = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var full = (0, _utils.fullPath)(path);
    if (templated) {
        return _tmpPromise2.default.dir({ unsafeCleanup: true }).then(function (o) {
            var temp = (0, _path.join)(o.path, _utils.PROXY_FOLDER);
            return (0, _applyTemplate2.default)(full, temp, placeholders).
            then(function () {
                var stream = toZip(temp);
                (0, _streamToPromise2.default)(stream).then(function () {return o.cleanup();});
                return stream;
            });
        });
    } else {
        return Promise.resolve(toZip(full));
    }
}