"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.default =
















updateMap;exports.




updateMapsFromObject = updateMapsFromObject;var _utils = require("../utils");var _logger = require("../logger");var _logger2 = _interopRequireDefault(_logger);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function toEntriesArray(name, values) {var array = (0, _utils.objectToArray)(values);for (var i = 0; i < array.length; ++i) {array[i].value = typeof array[i].value === "string" ? array[i].value : JSON.stringify(array[i].value);array[i].map_name = name;}return array;}function recreateMap(client, name, entries) {return client.deleteMap(name).then(function () {return client.createMap(name, { name: name, keyMapEntryValues: entries });});}function updateMap(client, name, keys) {return recreateMap(client, name, toEntriesArray(name, keys)).then(function () {return _logger2.default.debug("Successfully updated map " + name + ".");});}function updateMapsFromObject(client, maps) {
    var promises = [];
    for (var key in maps) {
        if (maps.hasOwnProperty(key)) {
            promises.push(updateMap(client, key, maps[key]));
        }
    }
    return Promise.all(promises);
}