"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.logger = exports.ApiManager = undefined;exports.
















































createConfigFile = createConfigFile;exports.default =













function () {var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultConfig();
    return new _ApiManager2.default(config);
};var _ApiManager = require("./ApiManager");var _ApiManager2 = _interopRequireDefault(_ApiManager);var _tmp = require("tmp");var _tmp2 = _interopRequireDefault(_tmp);var _fsExtra = require("fs-extra");var _path = require("path");var _os = require("os");var _logger = require("./logger");var _logger2 = _interopRequireDefault(_logger);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };} /**
                                                                                                                                                                                                                                                                                                                                                                                                                                             * API management tools module.
                                                                                                                                                                                                                                                                                                                                                                                                                                             * @module sapim
                                                                                                                                                                                                                                                                                                                                                                                                                                             */_tmp2.default.setGracefulCleanup();function loadConfig(path) {try {if ((0, _fsExtra.existsSync)(path)) {return JSON.parse((0, _fsExtra.readFileSync)(path, "utf8"));} else {return null;}} catch (e) {_logger2.default.warn("Unable to parse .sapim config file from: " + path + ". " + e.toString());return null;}}var defaultConfigCache = null;function defaultConfig() {if (!defaultConfigCache) {var fileConfig = loadConfig((0, _path.resolve)(".sapim")) || loadConfig((0, _path.join)((0, _os.homedir)(), ".sapim")) || {};defaultConfigCache = { username: process.env.SAPIM_USERNAME || fileConfig.username, password: process.env.SAPIM_PASSWORD || fileConfig.password, host: process.env.SAPIM_HOST || fileConfig.host, proxy: process.env.HTTPS_PROXY || fileConfig.proxy };}return defaultConfigCache;} /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       * Creates a .sapim configuration file.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       * @param {Configuration} content The content of the configuration file.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       * @param {boolean} [global=false] Flag indicating if the configuration should be global.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       * @param {boolean} [overwrite=false] Flag indicating if the existing configuration (if any) should
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       *  be overwritten.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       */function createConfigFile(content) {var global = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;var overwrite = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;var file = global ? (0, _path.join)((0, _os.homedir)(), ".sapim") : (0, _path.resolve)(".sapim");var opts = overwrite ? { flag: "w" } : { flag: "wx" };return (0, _fsExtra.writeFile)(file, JSON.stringify(content, null, 4), opts);} /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * Factory function for the API tools class.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * @function default
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * @static
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * @param {Configuration=} config The configuration used for creating the API tools.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     *  If ommited, the configuration is loaded from the environment and / or the file system.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * @returns {ApiManager} The API tools class instance.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     */exports.ApiManager = _ApiManager2.default;exports.logger = _logger2.default;