"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.PROXY_FOLDER = undefined;exports.










escapeRegExp = escapeRegExp;exports.



iterateThroughPattern = iterateThroughPattern;exports.










parseManifest = parseManifest;exports.














objectToArray = objectToArray;exports.












copyAndReplace = copyAndReplace;exports.














endsWith = endsWith;exports.



fullPath = fullPath;var _fsExtra = require("fs-extra");var _jsYaml = require("js-yaml");var _globPromise = require("glob-promise");var _globPromise2 = _interopRequireDefault(_globPromise);var _path = require("path");var _recursiveCopy = require("recursive-copy");var _recursiveCopy2 = _interopRequireDefault(_recursiveCopy);var _replace = require("replace");var _replace2 = _interopRequireDefault(_replace);var _logger = require("./logger");var _logger2 = _interopRequireDefault(_logger);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}var PROXY_FOLDER = exports.PROXY_FOLDER = "APIProxy";function escapeRegExp(str) {return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");}function iterateThroughPattern(pattern, callback) {return (0, _globPromise2.default)(pattern, { absolute: true }).then(function (paths) {_logger2.default.debug("Expanded pattern " + pattern + " to: " + paths.join(", ") + ".");var promise = Promise.resolve();var _loop = function _loop(i) {promise = promise.then(function () {return callback(paths[i]);});};for (var i = 0; i < paths.length; ++i) {_loop(i);}return promise;});}function parseManifest(path) {var promise = (0, _fsExtra.readFile)(path);if (path.toLowerCase().endsWith(".json")) {promise = promise.then(JSON.parse);} else {promise = promise.then(_jsYaml.safeLoad);}return promise.then(function (data) {if (data && data.proxy) {data.proxy.path = (0, _path.resolve)((0, _path.dirname)(path), data.proxy.path);}return data;});}function objectToArray(values) {var entries = [];for (var key in values) {if (values.hasOwnProperty(key)) {entries.push({ name: key, value: values[key] });}}return entries;}function copyAndReplace(source, target, replacements) {var promise = source === target ? Promise.resolve() : (0, _recursiveCopy2.default)(source, target, { overwrite: true });return promise.then(function () {for (var i = 0; i < replacements.length; ++i) {(0, _replace2.default)({ regex: replacements[i].regex, replacement: replacements[i].replacement, paths: [target], recursive: true, silent: true });}});}function endsWith(str, suffix) {return str.substring(str.length - suffix.length) === suffix;}function fullPath(path) {
    path = (0, _path.normalize)(path);
    if (!endsWith(path, _path.sep)) {
        path += _path.sep;
    }
    if (!endsWith(path, PROXY_FOLDER + _path.sep)) {
        path += PROXY_FOLDER + _path.sep;
    }
    return path;
}