"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.default =






deployManifest;exports.












deployManifestsMatching = deployManifestsMatching;var _path = require("path");var _logger = require("../logger");var _logger2 = _interopRequireDefault(_logger);var _utils = require("../utils");var _deployProxy = require("./deployProxy");var _deployProxy2 = _interopRequireDefault(_deployProxy);var _updateMap = require("./updateMap");function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function deployManifest(client, path) {return (0, _utils.parseManifest)(path).then(function (_ref) {var proxy = _ref.proxy,maps = _ref.maps;var promise = !proxy ? Promise.resolve() : (0, _deployProxy2.default)(client, proxy.path, proxy.templated, proxy.placeholders);return maps ? promise.then(function () {return (0, _updateMap.updateMapsFromObject)(client, maps);}) : promise;}).then(function () {return _logger2.default.info("Successfully deployed manifest: " + (0, _path.basename)(path) + ".");}).catch(function (e) {_logger2.default.error("Unable to deploy manifest: " + (0, _path.basename)(path) + ". " + e.toString());throw new Error("Unable to deploy manifest.");});}function deployManifestsMatching(client, pattern) {var force = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var wrap = force ? function (p) {return p.catch(function () {});} : function (p) {return p;};
    return (0, _utils.iterateThroughPattern)(pattern, function (path) {return wrap(deployManifest(client, path));});
}