"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.default =













uploadProxy;var _fs = require("fs");var _base64Stream = require("base64-stream");var _logger = require("../logger");var _logger2 = _interopRequireDefault(_logger);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function fileToStream(path) {try {return Promise.resolve((0, _fs.createReadStream)(path));} catch (e) {_logger2.default.error("Failed to upload zip file. " + e.toString());throw new Error("Failed to upload zip file.");}}function uploadProxy(client, pathOrStream) {
    var promise = typeof pathOrStream === "string" ? fileToStream(pathOrStream) : Promise.resolve(pathOrStream);
    return promise.then(function (stream) {return client.uploadProxy(stream.pipe((0, _base64Stream.encode)())).
        then(function () {return _logger2.default.debug("Successfully uploaded API Proxy archive.");});});
}