"use strict";Object.defineProperty(exports, "__esModule", { value: true });var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();exports.























































































setLogger = setLogger;function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}} /**
                                                                                                                                                                             * Logging helper module.
                                                                                                                                                                             * @module sapim/logger
                                                                                                                                                                             */ /**
                                                                                                                                                                                 * The severity of the message(s) logged.
                                                                                                                                                                                 * @enum {integer}
                                                                                                                                                                                 */var LOG_LEVEL = exports.LOG_LEVEL = { /** Debug level */DEBUG: 0, /** Info level */INFO: 1, /** Warning level */WARNING: 2, /** Alias for WARNING */WARN: 2, /** Erorr level */ERROR: 3, /** Silent level */SILENT: 100 }; /**
                                                                                                                                                                                                                                                                                                                                                                                                               * A simple logging wrapper around the console.
                                                                                                                                                                                                                                                                                                                                                                                                               * @class
                                                                                                                                                                                                                                                                                                                                                                                                               * @property {LOG_LEVEL} level The lowest severity level logged by the logger.
                                                                                                                                                                                                                                                                                                                                                                                                               */var DefaultLogger = function () {function DefaultLogger() {_classCallCheck(this, DefaultLogger);this.level = LOG_LEVEL.INFO;} /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Log a DEBUG-level message.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @param {string} message The message to be logged.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @returns {void}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */_createClass(DefaultLogger, [{ key: "debug", value: function debug(message) {if (this.level <= LOG_LEVEL.DEBUG) {console.log(message);}} /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * Log a INFO-level message.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * @param {string} message The message to be logged.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * @returns {void}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            */ }, { key: "info", value: function info(message) {if (this.level <= LOG_LEVEL.INFO) {console.info(message);}} /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             * Log a WARN-level message.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             * @param {string} message The message to be logged.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             * @returns {void}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             */ }, { key: "warn", value: function warn(message) {if (this.level <= LOG_LEVEL.WARNING) {console.warn(message);}} /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 * Log a ERROR-level message.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 * @param {string} message The message to be logged.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 * @returns {void}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 */ }, { key: "error", value: function error(message) {if (this.level <= LOG_LEVEL.ERROR) {console.error(message);}} }]);return DefaultLogger;}();var logger = new DefaultLogger(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * Overrides the default logger and sets a custom one (either a "subclass" of the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * DefaultLogger or an interface-compatible object).
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * @static
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * @param {DefaultLogger|object} customLogger The custom logger object.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * @returns {void}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     */function setLogger(customLogger) {logger = customLogger;}exports.default = logger;